#!/usr/bin/env bash

#
## Author: mail __AT__ wangbo __DOT__ im
#
#

# Enable strict bash mode
set -euo pipefail
IFS=$'\t\n'

URI_SCHEME="http"

DIRECT_HOST="10.144.69.53"
DIRECT_PORT="8080"
PROXY_HOST="10.145.67.20"
PROXY_PORT="8080"

UUID=$(uuidgen)
UUID="${1:-${UUID}}"

THREADS=16

ALL_CONNECTIONS=(
    100
    200
    300
)

ALL_QPS=(
     100
    1000
    5000
    10000
    15000
    20000
    25000
    30000
)

for each_arg1 in "${ALL_CONNECTIONS[@]}"; do
    for each_arg2 in "${ALL_QPS[@]}"; do
        connections="${each_arg1}"
        qps="${each_arg2}"

        CURL=(
        "/opt/service/loadtest/wrk2/wrk"
        #"/opt/service/loadtest/wrk/wrk"
        "-t"
        "${THREADS}"
        "-d"
        "60s"
        "--latency"
        "-c"
        "${connections}"
        "-R"
        "${qps}"
        )

        output_filename_prefix="${THREADS}.${connections}.${qps}.${UUID}"
        #output_filename_prefix="${THREADS}.${connections}.${UUID}"

        # for direct
        echo "${CURL[@]}" "${URI_SCHEME}://${DIRECT_HOST}:${DIRECT_PORT}/fast/instant"
        "${CURL[@]}" "${URI_SCHEME}://${DIRECT_HOST}:${DIRECT_PORT}/fast/instant" > "${output_filename_prefix}.direct"

        # for single host api0
        echo "${CURL[@]}" -H "Host: 0rest.58.com" "${URI_SCHEME}://${PROXY_HOST}:${PROXY_PORT}/entry/rest0"
        "${CURL[@]}" -H "Host: 0rest.58.com" "${URI_SCHEME}://${PROXY_HOST}:${PROXY_PORT}/entry/rest0" > "${output_filename_prefix}.api0_rest_backend"

        # for single host api800
        echo "${CURL[@]}" -H "Host: 800rest.58.com" "${URI_SCHEME}://${PROXY_HOST}:${PROXY_PORT}/entry/rest800"
        "${CURL[@]}" -H "Host: 800rest.58.com" "${URI_SCHEME}://${PROXY_HOST}:${PROXY_PORT}/entry/rest800" > "${output_filename_prefix}.api800_rest_backend"

        # for load balanced backend
        #echo "${CURL[@]}" -H "Host: 4fast.58.com" "${URI_SCHEME}://${URI_HOST}:${URI_PORT}/entry/fast4"
        #"${CURL[@]}" -H "Host: 4fast.58.com" "${URI_SCHEME}://${URI_HOST}:${URI_PORT}/entry/fast4" > "${output_filename_prefix}.loadbalanced_backend"
    done
done

# vim:nu:tabstop=4:shiftwidth=4:ft=sh
